Page MenuHomePhabricator

Figure out process for deleting an unused tool
Open, Needs TriagePublic

Description

See Toolforge (Tools to be deleted) for information on how to nominate a tool for deletion.

We have a growing list of tools that have been volunteered for deleting by their maintainers. We probably also have quite a large number of tools that are being "name squatted" and could be reclaimed with gentle prodding of their maintainers. But, we don't have a well defined process for what steps are actually necessary to delete a tool. We should make that checklist and then figure out if automating it is worthwhile or not.

Deletion checklist

  • Remove all maintainers from tool group
  • Remove tool from maintainers list for all other tools
  • Archive tool's crontab
  • Stop all running jobs owned by tool on job grid
  • Delete all deployments owned by the tool on Kubernetes
  • Revoke Kubernetes credentials for tool
  • Remove Kubernetes namespace for tool
  • Archive any ToolsDB databases owned by the tool
  • Revoke database credentials for tool
  • Revoke elasticsearch credentials for tool
  • Archive tool homedir
  • Archive any Diffusion repositories owned by the tool
  • Delete tool account and group from LDAP

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 11 2017, 10:20 PM

@valhallasw, @scfc, @yuvipanda, @madhuvishy, @Andrew, @chasemp: what am I forgetting? Update the list in the description please and thank you.

For everyone's understanding: This is a complement to T102066 (abandoned tools that nobody wants to take over and/or should die because of technical reasons)?

For everyone's understanding: This is a complement to T102066 (abandoned tools that nobody wants to take over and/or should die because of technical reasons)?

I think the tools that have been self-nominated so far are mostly failed experiments or things that have graduated to other hosting/folded into other tools. But, yes the archival step would be intended to preserve a record in case someone petitioned to revive the tool as a fork.

Framawiki added a subscriber: Framawiki.
Dvorapa added a subscriber: Dvorapa.Apr 9 2018, 7:16 AM

For everyone's understanding: This is a complement to T102066 (abandoned tools that nobody wants to take over and/or should die because of technical reasons)?

I think the tools that have been self-nominated so far are mostly failed experiments or things that have graduated to other hosting/folded into other tools. But, yes the archival step would be intended to preserve a record in case someone petitioned to revive the tool as a fork.

Yeah, I think some of them were created only for testing, learning Toolforge, or trying to create some tool and not be successful at all (like me). Also because of this there should be some more easier process to remove user's own tool within some time from creation (7 days?)..

zhuyifei1999 updated the task description. (Show Details)May 6 2018, 5:47 PM
zhuyifei1999 updated the task description. (Show Details)
Cirdan added a subscriber: Cirdan.May 23 2018, 3:23 PM
bd808 updated the task description. (Show Details)Feb 15 2019, 12:33 AM
bd808 updated the task description. (Show Details)Mar 17 2019, 10:13 PM

With a backlog of 45 (a.t.m.) requests for tool deletions, is the checklist above complete so we can start honoring (or at least study) those requests? Thanks.

With a backlog of 45 (a.t.m.) requests for tool deletions, is the checklist above complete so we can start honoring (or at least study) those requests? Thanks.

Having a list of abandoned tools is not a cause for alarm if the length of the list is 1 or 1000. Implementation of a repeatable cleanup process is a hard problem. I would like to devote some time in the coming months to attempting to find a resolution, but I am also in no hurry to do so. We now have a process documented in this task and on wikitech that can be used by tool maintainers to detach themselves from a tool they no longer wish to maintain. This was the most important aspect to solve. The remaining work is administrative and not something that should be a concern for the Toolforge maintainer community.

bd808 updated the task description. (Show Details)May 19 2019, 8:05 AM